/dts-v1/;

/memreserve/	0x0000000087800000 0x0000000000240000;
/memreserve/	0x0000000088000000 0x0000000001c00000;
/memreserve/	0x000000009effc000 0x0000000000465000;
/memreserve/	0x000000009f5fc000 0x0000000000a04000;
/ {
	#address-cells = <0x1>;
	#size-cells = <0x1>;
	compatible = "sprd,scx35";
	interrupt-parent = <0x1>;
	model = "Spreadtrum SP7730G board";
	sprd,sc-id = <0x227e 0x4 0x20000>;

	adc@40038300 {
		compatible = "sprd,sprd-adc";
		reg = <0xf53f8300 0x400>;
	};

	adi_bus {
		#address-cells = <0x1>;
		#interrupt-cells = <0x2>;
		#size-cells = <0x1>;
		compatible = "sprd,adi-bus";
		interrupt-controller;
		interrupts = <0x0 0x26 0x0>;
		linux,phandle = <0x32>;
		phandle = <0x32>;
		ranges = <0x40 0xf53f8040 0x40 0x80 0xf53f8080 0x80 0x100 0xf53f8100 0x80 0x480 0xf53f8480 0x80>;
		reg = <0xf53f8000 0x1000>;
		sprd,irqnums = <0xb>;

		gpio@100 {
			#gpio-cells = <0x2>;
			#interrupt-cells = <0x2>;
			compatible = "sprd,a-eic-gpio";
			gpio-controller;
			gpiobase = <0x130>;
			interrupt-controller;
			interrupt-parent = <0x32>;
			interrupts = <0x5 0x0>;
			linux,phandle = <0x33>;
			ngpios = <0x10>;
			phandle = <0x33>;
			reg = <0x100 0x80>;
		};

		gpio@480 {
			#gpio-cells = <0x2>;
			#interrupt-cells = <0x2>;
			compatible = "sprd,a-gpio-gpio";
			gpio-controller;
			gpiobase = <0x100>;
			interrupt-controller;
			interrupt-parent = <0x32>;
			interrupts = <0x1 0x0>;
			ngpios = <0x20>;
			reg = <0x480 0x80>;
		};

		headset_detect {
			adc_threshold_3pole_detect = <0x6a4>;
			adc_threshold_4pole_detect = <0xa8c>;
			compatible = "sprd,headset-detect";
			gpio_button = <0xef>;
			gpio_detect = <0xed>;
			gpio_switch = <0x0>;
			irq_threshold_buttont = <0x1>;
			irq_trigger_level_button = <0x0>;
			irq_trigger_level_detect = <0x0>;
			nbuttons = <0x3>;
			voltage_headmicbias = <0x2dc6c0>;

			headset_buttons_down {
				adc_max = <0x2f8>;
				adc_min = <0x15c>;
				code = <0x72>;
				type = <0x0>;
			};

			headset_buttons_media {
				adc_max = <0xbe>;
				adc_min = <0x0>;
				code = <0xe2>;
				type = <0x0>;
			};

			headset_buttons_up {
				adc_max = <0x15b>;
				adc_min = <0xbf>;
				code = <0x73>;
				type = <0x0>;
			};
		};

		headset_sprd_sc2723 {
			adc_threshold_3pole_detect = <0x42e>;
			adc_threshold_4pole_detect = <0xc1c>;
			compatible = "sprd,headset_sprd_sc2723";
			gpio_button = <0xef>;
			gpio_detect = <0xed>;
			gpio_switch = <0x0>;
			irq_threshold_buttont = <0x1>;
			irq_trigger_level_button = <0x0>;
			irq_trigger_level_detect = <0x0>;
			nbuttons = <0x3>;
			voltage_headmicbias = <0x2dc6c0>;

			headset_buttons_down {
				adc_max = <0xc1c>;
				adc_min = <0x16e>;
				code = <0x72>;
				type = <0x0>;
			};

			headset_buttons_media {
				adc_max = <0xb4>;
				adc_min = <0x0>;
				code = <0xe2>;
				type = <0x0>;
			};

			headset_buttons_up {
				adc_max = <0x16d>;
				adc_min = <0xb5>;
				code = <0x73>;
				type = <0x0>;
			};
		};

		rtc@80 {
			compatible = "sprd,rtc";
			interrupts = <0x2 0x0>;
			reg = <0x80 0x80>;
		};

		watchdog@40 {
			compatible = "sprd,watchdog";
			interrupts = <0x3 0x0>;
			reg = <0x40 0x40>;
		};
	};

	adic {
		compatible = "sprd,adic";
		reg = <0xf53f0000 0x1000>;
	};

	aliases {
		hwspinlock0 = "/hwspinlock0@20c00000";
		hwspinlock1 = "/hwspinlock1@40060000";
		i2c0 = "/i2c@f536a000";
		i2c1 = "/i2c@f536c000";
		i2c2 = "/i2c@f5370000";
		i2c3 = "/i2c@f5372000";
		i2c_gpio6 = "/i2c_gpio@0";
		i2c_gpio7 = "/i2c_gpio@2";
		lcd0 = "/fb@20800000";
		serial0 = "/uart@f5360000";
		serial1 = "/uart@f5362000";
		serial2 = "/uart@f5364000";
		serial3 = "/uart@f5366000";
		spi0 = "/spi@70a00000";
		spi1 = "/spi@70b00000";
		spi2 = "/spi@70c00000";
	};

	bcm-bt-lpm {
		compatible = "bcm,bcm-bt-lpm";
		gpios = <0x34 0xe8 0x0 0x34 0xeb 0x0>;
	};

	bcm-bt-rfkill {
		compatible = "bcm,bcm-bt-rfkill";
		gpios = <0x34 0xe7 0x0 0x34 0xe9 0x0>;
	};

	chosen {
		bootargs = "init=/init root=/dev/ram0 rw";
		linux,initrd-end = <0x855a3212>;
		linux,initrd-start = <0x85500000>;
	};

	clockdevice {
		#clock-cells = <0x1>;
		compatible = "sprd,scx35-clock";
		linux,phandle = <0x31>;
		phandle = <0x31>;
	};

	clocks {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		compatible = "sprd,scx30g-clocks";

		clk_104m {
			#clock-cells = <0x0>;
			clock-div = <0x6>;
			clock-mult = <0x1>;
			clock-output-names = "clk_104m";
			clocks = <0x6>;
			compatible = "sprd,fixed-factor-clock";
		};

		clk_128m {
			#clock-cells = <0x0>;
			clock-div = <0x6>;
			clock-mult = <0x1>;
			clock-output-names = "clk_128m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xb>;
			phandle = <0xb>;
		};

		clk_12m {
			#clock-cells = <0x0>;
			clock-div = <0x40>;
			clock-mult = <0x1>;
			clock-output-names = "clk_12m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1e>;
			phandle = <0x1e>;
		};

		clk_153m6 {
			#clock-cells = <0x0>;
			clock-div = <0x5>;
			clock-mult = <0x1>;
			clock-output-names = "clk_153m6";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xc>;
			phandle = <0xc>;
		};

		clk_192m {
			#clock-cells = <0x0>;
			clock-div = <0x4>;
			clock-mult = <0x1>;
			clock-output-names = "clk_192m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x19>;
			phandle = <0x19>;
		};

		clk_208m {
			#clock-cells = <0x0>;
			clock-div = <0x3>;
			clock-mult = <0x1>;
			clock-output-names = "clk_208m";
			clocks = <0x6>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1d>;
			phandle = <0x1d>;
		};

		clk_24m {
			#clock-cells = <0x0>;
			clock-div = <0x20>;
			clock-mult = <0x1>;
			clock-output-names = "clk_24m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1f>;
			phandle = <0x1f>;
		};

		clk_256m {
			#clock-cells = <0x0>;
			clock-div = <0x3>;
			clock-mult = <0x1>;
			clock-output-names = "clk_256m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1a>;
			phandle = <0x1a>;
		};

		clk_300m {
			#clock-cells = <0x0>;
			clock-div = <0x3>;
			clock-mult = <0x1>;
			clock-output-names = "clk_300m";
			clocks = <0x3>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x20>;
			phandle = <0x20>;
		};

		clk_312m {
			#clock-cells = <0x0>;
			clock-div = <0x2>;
			clock-mult = <0x1>;
			clock-output-names = "clk_312m";
			clocks = <0x6>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1b>;
			phandle = <0x1b>;
		};

		clk_37m5 {
			#clock-cells = <0x0>;
			clock-div = <0x18>;
			clock-mult = <0x1>;
			clock-output-names = "clk_37m5";
			clocks = <0x3>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x15>;
			phandle = <0x15>;
		};

		clk_384m {
			#clock-cells = <0x0>;
			clock-div = <0x2>;
			clock-mult = <0x1>;
			clock-output-names = "clk_384m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x1c>;
			phandle = <0x1c>;
		};

		clk_38m4 {
			#clock-cells = <0x0>;
			clock-div = <0x14>;
			clock-mult = <0x1>;
			clock-output-names = "clk_38m4";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xe>;
			phandle = <0xe>;
		};

		clk_40m_wf1 {
			#clock-cells = <0x0>;
			clock-div = <0x16>;
			clock-mult = <0x1>;
			clock-output-names = "clk_40m_wf1";
			clocks = <0x5>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x16>;
			phandle = <0x16>;
		};

		clk_460m8 {
			#clock-cells = <0x0>;
			clock-div = <0x2>;
			clock-mult = <0x1>;
			clock-output-names = "clk_460m8";
			clocks = <0x2>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x21>;
			phandle = <0x21>;
		};

		clk_48m {
			#clock-cells = <0x0>;
			clock-div = <0x10>;
			clock-mult = <0x1>;
			clock-output-names = "clk_48m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x12>;
			phandle = <0x12>;
		};

		clk_51m2 {
			#clock-cells = <0x0>;
			clock-div = <0xf>;
			clock-mult = <0x1>;
			clock-output-names = "clk_51m2";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xf>;
			phandle = <0xf>;
		};

		clk_51m2_w {
			#clock-cells = <0x0>;
			clock-div = <0x12>;
			clock-mult = <0x1>;
			clock-output-names = "clk_51m2_w";
			clocks = <0x2>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x14>;
			phandle = <0x14>;
		};

		clk_52m {
			#clock-cells = <0x0>;
			clock-div = <0xc>;
			clock-mult = <0x1>;
			clock-output-names = "clk_52m";
			clocks = <0x6>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x13>;
			phandle = <0x13>;
		};

		clk_64m {
			#clock-cells = <0x0>;
			clock-div = <0xc>;
			clock-mult = <0x1>;
			clock-output-names = "clk_64m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0x10>;
			phandle = <0x10>;
		};

		clk_66m_d {
			#clock-cells = <0x0>;
			clock-div = <0x8>;
			clock-mult = <0x1>;
			clock-output-names = "clk_66m_d";
			clocks = <0x4>;
			compatible = "sprd,fixed-factor-clock";
		};

		clk_76m8 {
			#clock-cells = <0x0>;
			clock-div = <0xa>;
			clock-mult = <0x1>;
			clock-output-names = "clk_76m8";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xd>;
			phandle = <0xd>;
		};

		clk_96m {
			#clock-cells = <0x0>;
			clock-div = <0x8>;
			clock-mult = <0x1>;
			clock-output-names = "clk_96m";
			clocks = <0x7>;
			compatible = "sprd,fixed-factor-clock";
			linux,phandle = <0xa>;
			phandle = <0xa>;
		};

		clk_adi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_adi";
			clocks = <0x8 0xe 0xf 0x10>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0034 0x3 0x402e0000 0x10000>;
		};

		clk_aon_apb {
			#clock-cells = <0x0>;
			clock-output-names = "clk_aon_apb";
			clocks = <0x8 0xd 0xa 0xb>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x18>;
			phandle = <0x18>;
			reg = <0x402d0028 0x3 0x402d0028 0x300>;
		};

		clk_ap_ahb {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ap_ahb";
			clocks = <0x8 0xd 0xb 0x19>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200020 0x3>;
		};

		clk_ap_apb {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ap_apb";
			clocks = <0x8 0x10 0xa 0xb>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200024 0x3>;
		};

		clk_aud {
			#clock-cells = <0x0>;
			clock-output-names = "clk_aud";
			clocks = <0x8>;
			compatible = "sprd,gate-clock";
			reg = <0x402e0000 0x40000>;
		};

		clk_audif {
			#clock-cells = <0x0>;
			clock-output-names = "clk_audif";
			clocks = <0x8 0xe 0xf>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d002c 0x3 0x402e0000 0x20000>;
		};

		clk_aux0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_aux0";
			clocks = <0x11 0x8 0x8 0x12 0x13 0x14 0x15 0x16>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x402e3020 0x7 0x402e3020 0xf0000 0x402e0004 0x4>;
		};

		clk_aux1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_aux1";
			clocks = <0x11 0x8 0x8 0x12 0x13 0x14 0x15 0x16>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x402e3020 0x70 0x402e3020 0xf00000 0x402e0004 0x8>;
		};

		clk_aux2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_aux2";
			clocks = <0x11 0x8 0x8 0x12 0x13 0x14 0x15 0x16>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x402e3020 0x700 0x402e3020 0xf000000 0x402e0004 0x10>;
		};

		clk_avs0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_avs0";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d005c 0x3 0x402e0000 0x40>;
		};

		clk_avs1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_avs1";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0060 0x3 0x402e0000 0x80>;
		};

		clk_ca7_axi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ca7_axi";
			clocks = <0x9>;
			compatible = "sprd,divider-clock";
			reg = <0x20d03000 0x700>;
		};

		clk_ca7_dap {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ca7_dap";
			clocks = <0x8 0xd 0xb 0xc>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d004c 0x3 0x402e0000 0x40000000>;
		};

		clk_ca7_dbg {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ca7_dbg";
			clocks = <0x9>;
			compatible = "sprd,divider-clock";
			reg = <0x20d03000 0x70000 0x20d00014 0x100>;
		};

		clk_ca7_ts {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ca7_ts";
			clocks = <0x11 0x8 0xb 0xc>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0050 0x3 0x402e0000 0x10000000>;
		};

		clk_ccir {
			#clock-cells = <0x0>;
			clock-output-names = "clk_ccir";
			clocks = <0x1f 0x26>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x44>;
			mm-domain;
			phandle = <0x44>;
			reg = <0x60e00028 0x10000 0x60d00000 0x2>;
		};

		clk_ccir_in {
			#clock-cells = <0x0>;
			clock-frequency = <0x3d09000>;
			clock-output-names = "clk_ccir_in";
			compatible = "sprd,fixed-clock";
			linux,phandle = <0x26>;
			phandle = <0x26>;
		};

		clk_cpll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_cpll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x6>;
			phandle = <0x6>;
			reg = <0x402e307c 0x7ff 0x402b00a4 0x1>;
		};

		clk_csi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_csi";
			clocks = <0x24>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x25>;
			mm-domain;
			phandle = <0x25>;
			reg = <0x60d00008 0x2 0x60d00000 0x10>;
		};

		clk_dcam {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dcam";
			clocks = <0xd 0xb 0x1a 0x1b>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x42>;
			mm-domain;
			phandle = <0x42>;
			reg = <0x60e0002c 0x3 0x60d00008 0x8 0x60d00000 0x1>;
		};

		clk_dcam_mipi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dcam_mipi";
			clocks = <0x25>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x45>;
			mm-domain;
			phandle = <0x45>;
			reg = <0x60d00008 0x1>;
		};

		clk_disp_emc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_disp_emc";
			clocks = <0x18>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x3b>;
			phandle = <0x3b>;
			reg = <0x402e0004 0x800>;
		};

		clk_dispc0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc0";
			clocks = <0xc 0x19 0x1a 0x1b>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x38>;
			phandle = <0x38>;
			reg = <0x7120002c 0x3 0x7120002c 0x700 0x20d00000 0x2>;
		};

		clk_dispc0_dbi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc0_dbi";
			clocks = <0xb 0xc 0x19 0x1a>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x39>;
			phandle = <0x39>;
			reg = <0x71200030 0x3 0x71200030 0x700 0x20d00000 0x2>;
		};

		clk_dispc0_dpi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc0_dpi";
			clocks = <0xb 0xc 0x19 0x1c>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x3a>;
			phandle = <0x3a>;
			reg = <0x71200034 0x3 0x71200034 0xff00 0x20d00000 0x2>;
		};

		clk_dispc1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc1";
			clocks = <0xc 0x19 0x1a 0x1b>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200038 0x3 0x71200038 0x700 0x20d00000 0x4>;
		};

		clk_dispc1_dbi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc1_dbi";
			clocks = <0xb 0xc 0x19 0x1a>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x7120003c 0x3 0x7120003c 0x700 0x20d00000 0x4>;
		};

		clk_dispc1_dpi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dispc1_dpi";
			clocks = <0xb 0xc 0x19 0x1c>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200040 0x3 0x71200040 0xff00 0x20d00000 0x4>;
		};

		clk_dpll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_dpll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x4>;
			phandle = <0x4>;
			reg = <0x402e3074 0x7ff 0x402b0098 0x1>;
		};

		clk_efuse {
			#clock-cells = <0x0>;
			clock-output-names = "clk_efuse";
			clocks = <0x8>;
			compatible = "sprd,gate-clock";
			reg = <0x402e0000 0x2000>;
		};

		clk_emc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_emc";
			clocks = <0x8 0x6 0x7 0x4>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x402d0024 0x3 0x402d0024 0x300>;
		};

		clk_emmc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_emmc";
			clocks = <0x8 0x1a 0x1b 0x1c>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x48>;
			phandle = <0x48>;
			reg = <0x71200054 0x3 0x20d00000 0x800>;
		};

		clk_fm {
			#clock-cells = <0x0>;
			clock-output-names = "clk_fm";
			clocks = <0x17>;
			compatible = "sprd,gate-clock";
			reg = <0x402e0000 0x2>;
		};

		clk_fm_in {
			#clock-cells = <0x0>;
			clock-frequency = <0x3d09000>;
			clock-output-names = "clk_fm_in";
			compatible = "sprd,fixed-clock";
			linux,phandle = <0x17>;
			phandle = <0x17>;
		};

		clk_gps {
			#clock-cells = <0x0>;
			clock-output-names = "clk_gps";
			clocks = <0x10 0xd>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200058 0x1 0x20d00000 0x1000>;
		};

		clk_gpu {
			#clock-cells = <0x0>;
			clock-output-names = "clk_gpu";
			clocks = <0xc 0x1d 0x1a 0x20 0x1b 0x1c 0x21>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x4d>;
			phandle = <0x4d>;
			reg = <0x60100004 0x7 0x60100004 0x30>;
		};

		clk_gpu_axi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_gpu_axi";
			clocks = <0x18>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x4c>;
			phandle = <0x4c>;
			reg = <0x402e0000 0x8000000 0x402b0021 0x2000000>;
		};

		clk_gsp {
			#clock-cells = <0x0>;
			clock-output-names = "clk_gsp";
			clocks = <0xa 0xc 0x19 0x1a>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x3d>;
			phandle = <0x3d>;
			reg = <0x71200028 0x3 0x20d00000 0x8>;
		};

		clk_gsp_emc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_gsp_emc";
			clocks = <0x18>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x3e>;
			phandle = <0x3e>;
			reg = <0x402e0004 0x2000>;
		};

		clk_i2c {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0058 0x3 0x402e0000 0x80000000>;
		};

		clk_i2c0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c0";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200078 0x3 0x71200078 0x700 0x71300000 0x100>;
		};

		clk_i2c1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c1";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x7120007c 0x3 0x7120007c 0x700 0x71300000 0x200>;
		};

		clk_i2c2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c2";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200080 0x3 0x71200080 0x700 0x71300000 0x400>;
		};

		clk_i2c3 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c3";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200084 0x3 0x71200084 0x700 0x71300000 0x800>;
		};

		clk_i2c4 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_i2c4";
			clocks = <0x8 0x12 0xf 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200088 0x3 0x71200088 0x700 0x71300000 0x1000>;
		};

		clk_iis0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_iis0";
			clocks = <0x8 0xb 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200098 0x3 0x71200098 0x700 0x71300000 0x2>;
		};

		clk_iis1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_iis1";
			clocks = <0x8 0xb 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x7120009c 0x3 0x7120009c 0x700 0x71300000 0x4>;
		};

		clk_iis2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_iis2";
			clocks = <0x8 0xb 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x712000a0 0x3 0x712000a0 0x700 0x71300000 0x8>;
		};

		clk_iis3 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_iis3";
			clocks = <0x8 0xb 0xc>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x712000a4 0x3 0x712000a4 0x700 0x71300000 0x10>;
		};

		clk_isp {
			#clock-cells = <0x0>;
			clock-output-names = "clk_isp";
			clocks = <0xd 0xb 0x1a 0x1b>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x46>;
			mm-domain;
			phandle = <0x46>;
			reg = <0x60e00034 0x3 0x60d00008 0x10 0x60d00000 0x4>;
		};

		clk_jpg {
			#clock-cells = <0x0>;
			clock-output-names = "clk_jpg";
			clocks = <0xd 0xb 0x19 0x1a>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x41>;
			mm-domain;
			phandle = <0x41>;
			reg = <0x60e00038 0x3 0x60d00008 0x40 0x60d00000 0x20>;
		};

		clk_mcu {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mcu";
			clocks = <0x8 0x4 0x6 0x7 0x5 0x2 0x3>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x9>;
			phandle = <0x9>;
			reg = <0x20d03000 0x7 0x20d03000 0x70>;
		};

		clk_mm {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mm";
			clocks = <0x18>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x22>;
			phandle = <0x22>;
			reg = <0x402e0000 0x2000000 0x402b001d 0x2000000>;
		};

		clk_mm_ahb {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mm_ahb";
			clocks = <0x8 0xa 0xb 0xc>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x24>;
			mm-domain;
			phandle = <0x24>;
			reg = <0x60e00020 0x3>;
		};

		clk_mm_axi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mm_axi";
			clocks = <0x22>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x23>;
			mm-domain;
			phandle = <0x23>;
			reg = <0x60d00008 0x80>;
		};

		clk_mm_ckg {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mm_ckg";
			clocks = <0x24>;
			compatible = "sprd,gate-clock";
			mm-domain;
			reg = <0x60d00000 0x40>;
		};

		clk_mm_mtx_axi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mm_mtx_axi";
			clocks = <0x23>;
			compatible = "sprd,gate-clock";
			mm-domain;
			reg = <0x60d00008 0x100>;
		};

		clk_mmu {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mmu";
			clocks = <0x24>;
			compatible = "sprd,gate-clock";
			linux,phandle = <0x4b>;
			mm-domain;
			phandle = <0x4b>;
			reg = <0x60d00000 0x80>;
		};

		clk_mpll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mpll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x3>;
			phandle = <0x3>;
			reg = <0x402e3070 0x7ff 0x402b0094 0x1>;
		};

		clk_mspi {
			#clock-cells = <0x0>;
			clock-output-names = "clk_mspi";
			clocks = <0x8 0x13 0xd 0xa>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0054 0x3 0x402e0000 0x800000>;
		};

		clk_nandc_2x {
			#clock-cells = <0x0>;
			clock-output-names = "clk_nandc_2x";
			clocks = <0x1d 0x1a 0x1b 0x1c>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x20d03038 0x3 0x20d03038 0xc 0x20d00000 0xe0000>;
		};

		clk_nandc_ecc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_nandc_ecc";
			clocks = <0xc 0x19>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200044 0x1 0x20d00000 0x80000 0x20d00000 0x20000>;
		};

		clk_probe {
			#clock-cells = <0x0>;
			clock-output-names = "clk_probe";
			clocks = <0x11 0x8 0x8 0x12 0x13 0x14 0x15 0x16>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x402e3020 0x7000 0x402e3020 0xf0000000 0x402e0004 0x20>;
		};

		clk_pub_ahb {
			#clock-cells = <0x0>;
			clock-output-names = "clk_pub_ahb";
			clocks = <0x8 0xa 0xb 0xc>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0020 0x3>;
		};

		clk_pwm0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_pwm0";
			clocks = <0x11 0x8>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0038 0x1 0x402e0000 0x10>;
		};

		clk_pwm1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_pwm1";
			clocks = <0x11 0x8>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d003c 0x1 0x402e0000 0x20>;
		};

		clk_pwm2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_pwm2";
			clocks = <0x11 0x8>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0040 0x1 0x402e0000 0x40>;
		};

		clk_pwm3 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_pwm3";
			clocks = <0x11 0x8>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0044 0x1 0x402e0000 0x80>;
		};

		clk_sdio0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_sdio0";
			clocks = <0x8 0x1a 0x1b 0x1c>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x49>;
			phandle = <0x49>;
			reg = <0x71200048 0x3 0x71200048 0x700 0x20d00000 0x100>;
		};

		clk_sdio1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_sdio1";
			clocks = <0x12 0xd 0xa 0xb>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x4a>;
			phandle = <0x4a>;
			reg = <0x7120004c 0x3 0x20d00000 0x200>;
		};

		clk_sdio2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_sdio2";
			clocks = <0x12 0xd 0xa 0xb>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200050 0x3 0x20d00000 0x400>;
		};

		clk_sensor {
			#clock-cells = <0x0>;
			clock-output-names = "clk_sensor";
			clocks = <0x8 0x12 0xd 0xa>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x43>;
			mm-domain;
			phandle = <0x43>;
			reg = <0x60e00024 0x3 0x60e00024 0x700 0x60d00008 0x4>;
		};

		clk_spi0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_spi0";
			clocks = <0x8 0xa 0xc 0x19>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x7120008c 0x3 0x7120008c 0x700 0x71300000 0x20>;
		};

		clk_spi1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_spi1";
			clocks = <0x8 0xa 0xc 0x19>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200090 0x3 0x71200090 0x700 0x71300000 0x40>;
		};

		clk_spi2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_spi2";
			clocks = <0x8 0xa 0xc 0x19>;
			compatible = "sprd,composite-dev-clock";
			linux,phandle = <0x3c>;
			phandle = <0x3c>;
			reg = <0x71200094 0x3 0x71200094 0x700 0x71300000 0x80>;
		};

		clk_tdpll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_tdpll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x7>;
			phandle = <0x7>;
			reg = <0x402e3078 0x7ff 0x402b009c 0x1>;
		};

		clk_thm {
			#clock-cells = <0x0>;
			clock-output-names = "clk_thm";
			clocks = <0x11 0x8>;
			compatible = "sprd,muxed-clock";
			reg = <0x402d0048 0x1 0x402e0004 0x2>;
		};

		clk_uart0 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_uart0";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200064 0x3 0x71200064 0x700 0x71300000 0x2000>;
		};

		clk_uart1 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_uart1";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200068 0x3 0x71200068 0x700 0x71300000 0x4000>;
		};

		clk_uart2 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_uart2";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x7120006c 0x3 0x7120006c 0x700 0x71300000 0x8000>;
		};

		clk_uart3 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_uart3";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200070 0x3 0x71200070 0x700 0x71300000 0x10000>;
		};

		clk_uart4 {
			#clock-cells = <0x0>;
			clock-output-names = "clk_uart4";
			clocks = <0x8 0x12 0xf 0xa>;
			compatible = "sprd,composite-dev-clock";
			reg = <0x71200074 0x3 0x71200074 0x700 0x71300000 0x20000>;
		};

		clk_usb_ref {
			#clock-cells = <0x0>;
			clock-output-names = "clk_usb_ref";
			clocks = <0x1e 0x1f>;
			compatible = "sprd,muxed-clock";
			reg = <0x71200060 0x1 0x20d00000 0x10>;
		};

		clk_vbc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_vbc";
			clocks = <0x8>;
			compatible = "sprd,gate-clock";
			reg = <0x402e0000 0x80000>;
		};

		clk_vsp {
			#clock-cells = <0x0>;
			clock-output-names = "clk_vsp";
			clocks = <0xd 0xb 0x19 0x1a>;
			compatible = "sprd,muxed-clock";
			linux,phandle = <0x40>;
			mm-domain;
			phandle = <0x40>;
			reg = <0x60e00030 0x3 0x60d00008 0x20 0x60d00000 0x8>;
		};

		clk_wifipll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_wifipll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x5>;
			phandle = <0x5>;
			reg = <0x402e3080 0x7ff 0x402b00a8 0x1>;
		};

		clk_wpll {
			#clock-cells = <0x0>;
			clock-output-names = "clk_wpll";
			compatible = "sprd,adjustable-pll-clock";
			linux,phandle = <0x2>;
			phandle = <0x2>;
			reg = <0x402e301c 0x7ff 0x402b00a0 0x1>;
		};

		clk_zip_emc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_zip_emc";
			clocks = <0x18>;
			compatible = "sprd,gate-clock";
			reg = <0x402e0004 0x1000>;
		};

		clk_zipdec {
			#clock-cells = <0x0>;
			clock-output-names = "clk_zipdec";
			clocks = <0xa 0xc 0x19 0x1a>;
			compatible = "sprd,muxed-clock";
			reg = <0x712000ac 0x3 0x20d00000 0x200000>;
		};

		clk_zipenc {
			#clock-cells = <0x0>;
			clock-output-names = "clk_zipenc";
			clocks = <0xa 0xc 0x19 0x1a>;
			compatible = "sprd,muxed-clock";
			reg = <0x712000a8 0x3 0x20d00000 0x100000>;
		};

		ext_26m {
			#clock-cells = <0x0>;
			clock-frequency = <0x18cba80>;
			clock-output-names = "ext_26m";
			compatible = "sprd,fixed-clock";
			linux,phandle = <0x8>;
			phandle = <0x8>;
		};

		ext_32k {
			#clock-cells = <0x0>;
			clock-frequency = <0x8000>;
			clock-output-names = "ext_32k";
			compatible = "sprd,fixed-clock";
			linux,phandle = <0x11>;
			phandle = <0x11>;
		};
	};

	cpus {
		#address-cells = <0x1>;
		#size-cells = <0x0>;

		cpu@f00 {
			compatible = "arm,cortex-a7";
			device_type = "cpu";
			reg = <0xf00>;
		};

		cpu@f01 {
			compatible = "arm,cortex-a7";
			device_type = "cpu";
			reg = <0xf01>;
		};

		cpu@f02 {
			compatible = "arm,cortex-a7";
			device_type = "cpu";
			reg = <0xf02>;
		};

		cpu@f03 {
			compatible = "arm,cortex-a7";
			device_type = "cpu";
			reg = <0xf03>;
		};
	};

	dmac@20100000 {
		compatible = "sprd,sprd-dma";
		interrupts = <0x0 0x32 0x0>;
		reg = <0xf5112000 0x4000>;
	};

	fb@20800000 {
		clock-names = "dispc_clk_parent", "dispc_dbi_clk_parent", "dispc_dpi_clk_parent", "dispc_emc_clk_parent", "dispc_clk", "dispc_dbi_clk", "dispc_dpi_clk", "dispc_emc_clk", "fb_spi_clock", "fb_spi_clock_parent";
		clock-src = <0xf424000 0xf424000 0x16e36000>;
		clocks = <0x1a 0x1a 0x1c 0x18 0x38 0x39 0x3a 0x3b 0x3c 0x8>;
		compatible = "sprd,sprdfb";
		dpi_clk_div = <0x7>;
		interrupts = <0x0 0x2e 0x0 0x0 0x30 0x0 0x0 0x31 0x0>;
		reg = <0xf5122000 0x1000 0xf5146000 0x1000>;
		sprd,fb_mem = <0x9effc000 0x465000>;
		sprd,fb_use_reservemem;
	};

	gpio@f5200000 {
		#gpio-cells = <0x2>;
		#interrupt-cells = <0x2>;
		compatible = "sprd,d-eic-gpio";
		gpio-controller;
		gpiobase = <0x120>;
		interrupt-controller;
		interrupts = <0x0 0x25 0x0>;
		ngpios = <0x10>;
		reg = <0xf5200000 0x1000>;
	};

	gpio@f5220000 {
		#gpio-cells = <0x2>;
		#interrupt-cells = <0x2>;
		compatible = "sprd,d-gpio-gpio";
		gpio-controller;
		gpiobase = <0x0>;
		interrupt-controller;
		interrupts = <0x0 0x23 0x0>;
		linux,phandle = <0x34>;
		ngpios = <0x100>;
		phandle = <0x34>;
		reg = <0xf5220000 0x1000>;
	};

	gpio_keys {
		compatible = "gpio-keys";

		home {
			debounce-interval = <0x2>;
			gpio = <0x34 0x71 0x1>;
			gpio-key,wakeup;
			label = "Home Key";
			linux,code = <0x66>;
		};
	};

	gps {
		compatible = "broadcom,bcm47520";
		gps-pwr-en = <0x34 0xa8 0x0>;
	};

	gpu {
		clock-names = "clk_gpu_axi", "clk_gpu", "clk_153m6", "clk_208m", "clk_256m", "clk_312m", "clk_384m", "clk_460m8";
		clocks = <0x4c 0x4d 0xc 0x1d 0x1a 0x1b 0x1c 0x21>;
		compatible = "sprd,mali-utgard";
		interrupt-names = "mali_gp_irq", "mali_gp_mmu_irq", "mali_pp0_irq", "mali_pp0_mmu_irq", "mali_pp1_irq", "mali_pp1_mmu_irq";
		interrupts = <0x0 0x27 0x0 0x0 0x27 0x0 0x0 0x27 0x0 0x0 0x27 0x0 0x0 0x27 0x0 0x0 0x27 0x0>;
		mali_pp_core_number = <0x4>;
		reg = <0x60001000 0x200 0x60000000 0x100 0x60003000 0x100 0x60008000 0x1100 0x60004000 0x100 0x6000a000 0x1100 0x60005000 0x100 0x60002000 0x100>;
		reg-names = "mali_l2", "mali_gp", "mali_gp_mmu", "mali_pp0", "mali_pp0_mmu", "mali_pp1", "mali_pp1_mmu", "mali_pmu";
	};

	gsp@20a00000 {
		clock-names = "clk_gsp", "clk_gsp_emc", "clk_gsp_parent", "clk_aon_apb";
		clocks = <0x3d 0x3e 0x1a 0x18>;
		compatible = "sprd,gsp";
		gsp_mmu_ctrl_base = <0xf5418000>;
		interrupts = <0x0 0x33 0x0>;
		reg = <0xf5126000 0x1000>;
	};

	hwspinlock0@20c00000 {
		compatible = "sprd,sprd-hwspinlock";
		reg = <0xf512a000 0x1000>;
	};

	hwspinlock1@40060000 {
		compatible = "sprd,sprd-hwspinlock";
		reg = <0xf51f6000 0x1000>;
	};

	i2c@f536a000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "sprd,i2c";
		interrupts = <0x0 0xb 0x0>;
		reg = <0xf536a000 0x1000>;

		sensor_main@0x3c {
			compatible = "sprd,sensor_main";
			reg = <0x3c>;
		};

		sensor_sub@0x21 {
			compatible = "sprd,sensor_sub";
			reg = <0x21>;
		};
	};

	i2c@f536c000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "sprd,i2c";
		interrupts = <0x0 0xc 0x0>;
		reg = <0xf536c000 0x1000>;

		ist30xx_ts@50 {
			compatible = "Imagis,IST30XX";
			gpios = <0x34 0x52 0x0>;
			reg = <0x50>;
		};
	};

	i2c@f5370000 {
		#address-cells = <0x1>;
		compatible = "sprd,i2c";
		interrupts = <0x0 0xd 0x0>;
		reg = <0xf5370000 0x1000>;
		status = "okay";

		gp2a-i2c@44 {
			compatible = "gp2a-i2c";
			gp2a-i2c,irq-gpio = <0x34 0xa2 0x0>;
			gp2a-leda-supply = <0x37>;
			gp2a-vdd-supply = <0x35>;
			gp2a-vio-supply = <0x36>;
			interrupt-parent = <0x34>;
			interrupts = <0xa2 0x0>;
			reg = <0x44>;
		};

		k2hh@1D {
			compatible = "stm,k2hh";
			interrupt-parent = <0x34>;
			interrupts = <0xa4 0x0>;
			reg = <0x1d>;
			stm,axis_map_x = <0x0>;
			stm,axis_map_y = <0x1>;
			stm,axis_map_z = <0x2>;
			stm,irq_gpio = <0x34 0xa4 0x0>;
			stm,min_interval = <0x2>;
			stm,negate_x = <0x0>;
			stm,negate_y = <0x1>;
			stm,negate_z = <0x0>;
			stm,poll_interval = <0x64>;
			stm,reg_vdd-supply = <0x35>;
			stm,reg_vio-supply = <0x36>;
		};
	};

	i2c@f5372000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "sprd,i2c";
		interrupts = <0x0 0xe 0x0>;
		reg = <0xf5372000 0x1000>;
	};

	i2c_gpio@0 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "i2c-gpio";
		gpios = <0x34 0x9f 0x0 0x34 0xa0 0x0>;
		i2c-gpio,delay-us = <0xa>;
		i2c-gpio,timeout-ms = <0x0>;

		sm5701-i2c@49 {
			compatible = "sm,sm5701";
			reg = <0x49>;

			chargermfd {

				charger {
					chg-float-voltage = <0x1130>;
					chgen-gpio = <0x34 0xd7 0x0>;
					chgirq-gpio = <0x34 0xa1 0x0>;
					compatible = "sm,sm5701-charger";
				};
			};

			leds_sm5701 {
				compatible = "sm,leds_sm5701";
				flashen-gpio = <0x34 0x51 0x0>;
				flashtorch-gpio = <0x34 0x53 0x0>;
			};
		};
	};

	i2c_gpio@2 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "i2c-gpio";
		gpios = <0x34 0x96 0x0 0x34 0x97 0x0>;
		i2c-gpio,delay-us = <0xa>;
		i2c-gpio,timeout-ms = <0x0>;

		sm5504@14 {
			compatible = "SiliconMitus,sm5504";
			interrupt-parent = <0x34>;
			reg = <0x14>;
			sm5504,irq-gpio = <0x34 0x95 0x0>;
		};
	};

	interrupt-controller@12001000 {
		#address-cells = <0x0>;
		#interrupt-cells = <0x3>;
		compatible = "arm,cortex-a15-gic", "arm,cortex-a9-gic";
		interrupt-controller;
		linux,phandle = <0x1>;
		phandle = <0x1>;
		reg = <0x12001000 0x1000 0x12002000 0x1000>;
	};

	ion {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "sprd,ion-sprd";

		sprd,ion-heap@1 {
			reg = <0x1>;
			reg-names = "ion_heap_system";
			sprd,ion-heap-mem = <0x0 0x0>;
			sprd,ion-heap-type = <0x0>;
		};

		sprd,ion-heap@2 {
			reg = <0x2>;
			reg-names = "ion_heap_carveout_mm";
			sprd,ion-heap-mem = <0x0 0x0>;
			sprd,ion-heap-type = <0x0>;
		};

		sprd,ion-heap@3 {
			reg = <0x3>;
			reg-names = "ion_heap_carveout_overlay";
			sprd,ion-heap-mem = <0x9f900000 0x700000>;
			sprd,ion-heap-type = <0x2>;
		};
	};

	keypad@f5208000 {
		#sprd,support_long_key;
		compatible = "sprd,sci-keypad";
		gpios = <0x33 0x2 0x0>;
		interrupts = <0x0 0x24 0x0>;
		linux,keypad-no-autorepeat;
		reg = <0xf5208000 0x1000>;
		sprd,debounce_time = <0x1388>;
		sprd,keypad-cols-choose-hw = <0x700>;
		sprd,keypad-num-columns = <0x3>;
		sprd,keypad-num-rows = <0x2>;
		sprd,keypad-rows-choose-hw = <0x30000>;

		key_home {
			keypad,column = <0x1>;
			keypad,row = <0x0>;
			linux,code = <0x66>;
		};

		key_volume_down {
			keypad,column = <0x0>;
			keypad,row = <0x1>;
			linux,code = <0x72>;
		};

		key_volume_up {
			keypad,column = <0x0>;
			keypad,row = <0x0>;
			linux,code = <0x73>;
		};

		key_volume_up1 {
			keypad,column = <0x2>;
			keypad,row = <0x0>;
			linux,code = <0x73>;
		};
	};

	memory {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		device_type = "memory";
		reg = <0x80000000 0x40000000>;
	};

	panel {
		compatible = "sprd,sprdfb-dsi-panel";
		gen-panel = <0x4e>;
		gen-panel-esd-en;
		gen-panel-esd-gpio = <0x34 0xec 0x0>;
		gen-panel-esd-type = <0x1>;
		interrupt-parent = <0x34>;
		interrupts = <0xec 0x1>;
		pinctrl-names = "default";

		gen-panel {
			linux,phandle = <0x4e>;
			phandle = <0x4e>;

			gen-panel-hx8369b-pls-wVGA-video {
				gen-panel-bus-width = <0x18>;
				gen-panel-color-mode-pol = <0x1>;
				gen-panel-de-pol = <0x0>;
				gen-panel-dev-id = <0x0>;
				gen-panel-direction = <0x0>;
				gen-panel-disable-cmds = [05 00 00 14 00 01 28 05 00 00 82 00 01 10];
				gen-panel-enable-cmds = [05 00 00 82 00 01 11 05 00 00 14 00 01 29];
				gen-panel-h-back-porch = <0x5a>;
				gen-panel-h-front-porch = <0x91>;
				gen-panel-h-sync-pol = <0x0>;
				gen-panel-h-sync-width = <0x46>;
				gen-panel-height = <0x64>;
				gen-panel-id = <0x55b890>;
				gen-panel-init-cmds = [39 00 00 0a 00 04 b9 ff 83 69 39 00 00 00 00 0b b1 0b 83 77 00 0f 0f 0b 0b 0c 0a 39 00 00 00 00 04 c6 41 ff 7d 39 00 00 00 00 05 e3 00 00 00 00 39 00 00 00 00 07 c0 73 50 00 34 c4 00 39 00 00 00 00 04 c3 55 b8 90 39 00 00 00 00 10 ba 31 00 16 ca b1 0a 00 10 28 02 21 21 9a 1a 8f 15 00 00 00 00 02 3a 70 39 00 00 00 00 05 b3 83 00 31 03 15 00 00 00 00 02 b4 00 15 00 00 00 00 02 cc 0e 15 00 00 00 00 02 ea 72 15 00 00 00 00 02 b2 03 39 00 00 00 00 5d d5 00 00 07 00 09 00 00 10 01 00 00 00 01 42 37 00 00 08 2a 08 47 00 00 03 00 00 00 00 00 00 00 00 00 00 00 15 00 00 98 98 44 66 00 22 51 00 00 89 98 33 11 77 55 04 00 00 98 98 55 77 11 33 40 00 00 89 98 22 00 66 44 15 00 00 00 01 00 00 00 03 00 0f ff ff 03 00 0f ff ff 00 8c 5a 39 00 00 00 00 24 e0 00 02 04 2c 33 3f 0d 32 05 0b 0e 11 14 12 13 13 1a 00 02 04 2c 32 3f 0f 31 05 0b 0e 11 14 12 13 13 1a 01 39 00 00 05 00 03 c9 0f 00];
				gen-panel-lanes = <0x2>;
				gen-panel-manu = "SDC";
				gen-panel-mdnie-browser-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-camera-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-ebook-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 a9 00 ea 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-email-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 b1 00 e5 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-gallery-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-negative-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-ui-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-video-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-vt-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-name = "hx8369b";
				gen-panel-phy-feq = <0x756e8>;
				gen-panel-pkt-dinfo-addr-length = <0x1>;
				gen-panel-pkt-dinfo-addr-offset = <0x0>;
				gen-panel-pkt-dinfo-data-length = <0x1>;
				gen-panel-pkt-dinfo-data-offset = <0x1>;
				gen-panel-read-id = [da 00 01 db 00 01 dc 00 01];
				gen-panel-read-status-ok = [9a];
				gen-panel-read-status-reg = [0a];
				gen-panel-refresh = <0x3c>;
				gen-panel-shut-down-pol = <0x1>;
				gen-panel-suspend-mode = <0x1>;
				gen-panel-te-pol = <0x0>;
				gen-panel-type = <0x2>;
				gen-panel-v-back-porch = <0xc>;
				gen-panel-v-front-porch = <0xa>;
				gen-panel-v-sync-pol = <0x0>;
				gen-panel-v-sync-width = <0x4>;
				gen-panel-width = <0x3c>;
				gen-panel-work-mode = <0x1>;
				gen-panel-xres = <0x1e0>;
				gen-panel-yres = <0x320>;
				status = "okay";
			};

			gen-panel-hx8369b-wVGA-video {
				gen-panel-backlight-get-brightness-reg = <0x52>;
				gen-panel-backlight-on-cmds = <0x15000000 0x25324>;
				gen-panel-backlight-set-brightness-cmds = <0x15000000 0x25100>;
				gen-panel-backlight-set-brightness-reg = <0x51>;
				gen-panel-bus-width = <0x18>;
				gen-panel-color-mode-pol = <0x1>;
				gen-panel-de-pol = <0x0>;
				gen-panel-dev-id = <0x0>;
				gen-panel-direction = <0x0>;
				gen-panel-disable-cmds = [05 00 00 96 00 01 28 05 00 00 96 00 01 10];
				gen-panel-enable-cmds = [05 00 00 b4 00 01 11 05 00 00 0a 00 01 29];
				gen-panel-h-back-porch = <0x6e>;
				gen-panel-h-front-porch = <0x6e>;
				gen-panel-h-sync-pol = <0x0>;
				gen-panel-h-sync-width = <0x4>;
				gen-panel-height = <0x64>;
				gen-panel-id = <0x55c090>;
				gen-panel-init-cmds = [39 00 00 0a 00 04 b9 ff 83 69 39 00 00 00 00 10 ba 31 00 16 ca b1 0a 00 10 28 02 21 21 9a 1a 8f 39 00 00 00 00 5d d5 00 00 07 00 09 00 00 10 01 00 00 00 01 42 37 00 00 08 2a 08 47 00 00 03 00 00 00 00 00 00 00 00 00 00 00 15 00 00 98 98 44 66 00 22 51 00 00 89 98 33 11 77 55 04 00 00 98 98 55 77 11 33 40 00 00 89 98 22 00 66 44 15 00 00 00 01 00 00 00 03 00 0f ff ff 03 00 0f ff ff 00 8c 5a 15 00 00 00 00 02 3a 70 15 00 00 00 00 02 36 00 39 00 00 00 00 0b b1 0b 83 77 00 0f 0f 16 16 0c 0a 15 00 00 00 00 02 b2 03 39 00 00 00 00 05 b3 83 00 31 03 15 00 00 00 00 02 b4 00 39 00 00 00 00 03 b6 a3 a3 15 00 00 00 00 02 cc 0c 39 00 00 00 00 07 c0 73 50 00 34 c4 00 39 00 00 00 00 05 e3 00 00 00 00 15 00 00 00 00 02 ea 72 39 00 00 00 00 04 c6 41 ff 7d 39 00 00 00 00 24 e0 01 0d 18 14 13 2f 31 3b 09 10 12 16 17 16 16 11 14 01 0d 18 14 13 2f 30 3b 09 10 11 16 17 15 16 11 14 01 39 00 00 00 00 80 c1 03 00 06 0d 15 1d 25 2d 35 3d 45 4d 55 5d 65 6d 75 7c 84 8c 94 9c a4 ac b4 bc c4 cc d4 dc e4 ec f3 fd 0f fa 95 40 ff aa 54 03 c0 00 07 0f 17 1f 27 2f 37 3f 47 4f 57 5f 67 6f 77 7f 87 8f 97 9f a7 af b7 bf c7 cf d7 df e7 ef f7 ff 00 00 00 00 00 00 00 00 00 00 07 0f 17 1f 27 2f 37 3f 47 4f 57 5f 67 6f 77 7f 87 8f 97 9f a7 af b7 bf c7 cf d7 df e7 ef f7 ff 00 00 00 00 00 00 00 00 00 39 00 00 05 00 03 c9 0f 00];
				gen-panel-lanes = <0x2>;
				gen-panel-manu = "SDC";
				gen-panel-mdnie-browser-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-camera-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-ebook-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 a9 00 ea 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-email-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 b1 00 e5 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-gallery-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-negative-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-ui-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-video-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-vt-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-name = "hx8369b";
				gen-panel-phy-feq = <0x756e8>;
				gen-panel-pkt-dinfo-addr-length = <0x1>;
				gen-panel-pkt-dinfo-addr-offset = <0x0>;
				gen-panel-pkt-dinfo-data-length = <0x1>;
				gen-panel-pkt-dinfo-data-offset = <0x1>;
				gen-panel-read-id = [da 00 01 db 00 01 dc 00 01];
				gen-panel-read-status-ok = [9a];
				gen-panel-read-status-reg = [0a];
				gen-panel-refresh = <0x3c>;
				gen-panel-shut-down-pol = <0x1>;
				gen-panel-suspend-mode = <0x1>;
				gen-panel-te-pol = <0x0>;
				gen-panel-type = <0x2>;
				gen-panel-v-back-porch = <0xc>;
				gen-panel-v-front-porch = <0xa>;
				gen-panel-v-sync-pol = <0x0>;
				gen-panel-v-sync-width = <0x4>;
				gen-panel-width = <0x3c>;
				gen-panel-work-mode = <0x1>;
				gen-panel-xres = <0x1e0>;
				gen-panel-yres = <0x320>;
				status = "okay";
			};

			gen-panel-nt35502-wVGA-video {
				gen-panel-backlight-get-brightness-reg = <0x52>;
				gen-panel-backlight-on-cmds = <0x15000000 0x25324>;
				gen-panel-backlight-set-brightness-cmds = <0x15000000 0x25100>;
				gen-panel-backlight-set-brightness-reg = <0x51>;
				gen-panel-bus-width = <0x18>;
				gen-panel-color-mode-pol = <0x1>;
				gen-panel-de-pol = <0x0>;
				gen-panel-dev-id = <0x0>;
				gen-panel-direction = <0x0>;
				gen-panel-disable-cmds = [05 00 00 96 00 01 28 05 00 00 96 00 01 10];
				gen-panel-enable-cmds = [05 00 00 78 00 01 11 05 00 00 64 00 01 29];
				gen-panel-h-back-porch = <0x6e>;
				gen-panel-h-front-porch = <0x6e>;
				gen-panel-h-sync-pol = <0x0>;
				gen-panel-h-sync-width = <0x4>;
				gen-panel-height = <0x64>;
				gen-panel-id = <0x554cc0>;
				gen-panel-init-cmds = <0x39000000 0x6f055 0xaa520801 0x39000000 0x2b008 0x39000000 0x2b240 0x39000000 0x2b328 0x39000000 0x2b419 0x39000000 0x2b554 0x39000000 0x2b936 0x39000000 0x2ba26 0x39000000 0x3bca0 0x390000 0x3bd 0xa0003900 0x11 0xd1006500 0x8800c900 0xd700eb01 0x12013301 0x65390000 0x11d2 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11d302 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5d4033a 0x39a3900 0x11 0xd5006500 0x8800c900 0xd700eb01 0x12013301 0x65390000 0x11d6 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11d702 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5d8033a 0x39a3900 0x11 0xd9006500 0x8800c900 0xd700eb01 0x12013301 0x65390000 0x11dd 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11de02 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5df033a 0x39a3900 0x11 0xe0003b00 0x5e00c900 0xd700eb01 0x12013301 0x65390000 0x11e1 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11e202 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5e3033a 0x39a3900 0x11 0xe4003b00 0x5e00c900 0xd700eb01 0x12013301 0x65390000 0x11e5 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11e602 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5e7033a 0x39a3900 0x11 0xe8003b00 0x5e00c900 0xd700eb01 0x12013301 0x65390000 0x11e9 0x18b01c2 0x1ea0221 0x24c024d 0x2720296 0x39000000 0x11ea02 0xaa02c102 0xcf02e302 0xef02ff03 0xb031b39 0x0 0x5eb033a 0x39a3900 0x6 0xf055aa52 0x8003900 0x3 0xb1160039 0x0 0x3b40850 0x39000000 0x2b603 0x39000000 0x3b7f0 0xf0390000 0x3b8 0x1073900 0x2 0xbc023900 0x4 0xbbfff500 0x39000000 0x13c880 0x466446 0x64466446 0x6464ffff 0x64646464 0x64390000 0x2b3 0x20390000 0x6f0 0x55aa5200 0x390000 0x5ff 0xaa552501 0x39000000 0x26f02 0x39000000 0x2f457 0x39000000 0x26f13 0x39000000 0x2f216 0x39000000 0x5ffaa 0x55250039 0x0 0x2b32039 0x0 0x2360039 0x0 0x2350039 0x0 0x6f055aa 0x52080039 0x0 0x3b36002 0x39000000 0x6f055 0xaa520801 0x39000000 0x26f02 0x39000000 0x2c8c0 0x39000000 0x6f055 0xaa520800 0x39000000 0x2b311 0x15000000 0x25500>;
				gen-panel-lanes = <0x2>;
				gen-panel-manu = "SDC";
				gen-panel-mdnie-browser-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-camera-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-ebook-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 a9 00 ea 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-email-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 b1 00 e5 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-gallery-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-negative-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-ui-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-video-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-vt-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-name = "nt35502";
				gen-panel-phy-feq = <0x79d38>;
				gen-panel-pkt-dinfo-addr-length = <0x1>;
				gen-panel-pkt-dinfo-addr-offset = <0x0>;
				gen-panel-pkt-dinfo-data-length = <0x1>;
				gen-panel-pkt-dinfo-data-offset = <0x1>;
				gen-panel-read-id = [da 00 01 db 00 01 dc 00 01];
				gen-panel-read-status-ok = [9a];
				gen-panel-read-status-reg = [0a];
				gen-panel-refresh = <0x3c>;
				gen-panel-shut-down-pol = <0x1>;
				gen-panel-suspend-mode = <0x1>;
				gen-panel-te-pol = <0x0>;
				gen-panel-type = <0x2>;
				gen-panel-v-back-porch = <0xc>;
				gen-panel-v-front-porch = <0xa>;
				gen-panel-v-sync-pol = <0x0>;
				gen-panel-v-sync-width = <0x4>;
				gen-panel-width = <0x3c>;
				gen-panel-work-mode = <0x1>;
				gen-panel-xres = <0x1e0>;
				gen-panel-yres = <0x320>;
				status = "okay";
			};

			gen-panel-sc7798d-wVGA-video {
				gen-panel-bus-width = <0x18>;
				gen-panel-color-mode-pol = <0x1>;
				gen-panel-de-pol = <0x0>;
				gen-panel-dev-id = <0x0>;
				gen-panel-direction = <0x0>;
				gen-panel-disable-cmds = [05 00 00 14 00 01 28 05 00 00 82 00 01 10];
				gen-panel-enable-cmds = [05 00 00 82 00 01 11 05 00 00 14 00 01 29];
				gen-panel-h-back-porch = <0x5a>;
				gen-panel-h-front-porch = <0x91>;
				gen-panel-h-sync-pol = <0x0>;
				gen-panel-h-sync-width = <0x46>;
				gen-panel-height = <0x64>;
				gen-panel-id = <0x55b8f0>;
				gen-panel-init-cmds = <0x39000000 0x4b9f1 0x8003900 0x8 0xb1310c0c 0xa73301b7 0x39000000 0x4c600 0xfd3900 0x5 0xe3030303 0x3390000 0xa0003b8 0x6223900 0x13 0xba310044 0x25910a00 0xc23400 0x4021d 0xb9ee4039 0x0 0x9b30000 0xc0a 0x25201500 0x2 0xb4001500 0x2 0xcc0e1500 0x2 0xbc671500 0x2 0xb2033900 0x50006 0xc0735000 0x8703900 0x34 0xe9000006 0x6e29 0x12300048 0x86e2947 0x3000000 0x1800 0x899833 0x11775513 0x8998 0x22006644 0x2000000 0x0 0x0 0x39000000 0x25ea00 0x989844 0x66002220 0x9898 0x55771133 0x31300000 0xff010000 0x0 0x0 0x39 0x0 0x23e00109 0xd2e363f 0x1031070d 0x11151316 0x15323801 0x5053035 0x3f0e3004 0x90a0d12 0xd0f2c35>;
				gen-panel-lanes = <0x2>;
				gen-panel-manu = "SDC";
				gen-panel-mdnie-browser-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-camera-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-ebook-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 a9 00 ea 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-email-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 b1 00 e5 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-gallery-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-negative-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 32 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff ff 00 ff 00 ff 00 00 ff 00 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 04 00];
				gen-panel-mdnie-ui-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-video-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-mdnie-vt-mode-cmds = [39 00 00 00 00 71 e6 5a 00 00 23 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 00 ff 00 ff 00 ff ff 00 02 ff 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 20 00 04 b5 1f 88 1f c3 1f e9 04 54 1f c3 1f e9 1f 88 04 8f];
				gen-panel-name = "sc7798d";
				gen-panel-phy-feq = <0x756e8>;
				gen-panel-pkt-dinfo-addr-length = <0x1>;
				gen-panel-pkt-dinfo-addr-offset = <0x0>;
				gen-panel-pkt-dinfo-data-length = <0x1>;
				gen-panel-pkt-dinfo-data-offset = <0x1>;
				gen-panel-read-id = [da 00 01 db 00 01 dc 00 01];
				gen-panel-read-status-ok = [9a];
				gen-panel-read-status-reg = [0a];
				gen-panel-refresh = <0x3c>;
				gen-panel-shut-down-pol = <0x1>;
				gen-panel-suspend-mode = <0x1>;
				gen-panel-te-pol = <0x0>;
				gen-panel-type = <0x2>;
				gen-panel-v-back-porch = <0xc>;
				gen-panel-v-front-porch = <0xa>;
				gen-panel-v-sync-pol = <0x0>;
				gen-panel-v-sync-width = <0x4>;
				gen-panel-width = <0x3c>;
				gen-panel-work-mode = <0x1>;
				gen-panel-xres = <0x1e0>;
				gen-panel-yres = <0x320>;
				status = "okay";
			};
		};

		panel-ext-pin {
		};
	};

	panel_cabc_bl {
		compatible = "sprd,panel_cabc_bl";
	};

	pinctrl {
		compatible = "sprd,pinctrl";
		ctrl_desc = <0x10 0x0 0x1 0x10 0x1 0x1 0x10 0x2 0x1 0x10 0x3 0x1 0x10 0x4 0x1 0x10 0x5 0x1 0x10 0x6 0x1 0x10 0x7 0x1>;
		pwr_domain = "vdd18", "vdd18", "vddsim0", "vddsim1", "vdd18", "vddsdcore", "vdd18";
		reg = <0xf5224000 0x1000>;
	};

	pmu {
		compatible = "arm,cortex-a7-pmu";
		interrupts = <0x0 0x5c 0x400 0x0 0x5d 0x400 0x0 0x5e 0x400 0x0 0x5f 0x400>;
	};

	regulators {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		compatible = "sprd,sc2723-regulator";

		dummy {
		};

		vdd18 {
			default-on;
			linux,phandle = <0x36>;
			phandle = <0x36>;
			reg = <0x40038810 0x2 0x4003883c 0x7f00 0x400388c0 0x400>;
			regulator-cal-channel = <0x40038844 0x1 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x1dc130>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vdd18";
			regulator-step-microvolt = <0x186a>;
		};

		vdd25 {
			reg = <0x40038810 0x8 0x40038840 0xff 0x400388c0 0x40>;
			regulator-cal-channel = <0x40038844 0x100 0x16>;
			regulator-default-microvolt = <0x2ab980>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vdd25";
			regulator-step-microvolt = <0x2710>;
		};

		vdd28 {
			default-on;
			reg = <0x40038810 0x4 0x40038824 0xff 0x400388c0 0x200>;
			regulator-cal-channel = <0x40038844 0xc0 0x17>;
			regulator-default-microvolt = <0x2ab980>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vdd28";
			regulator-step-microvolt = <0x2710>;
		};

		vddarm {
			dcdc;
			default-on;
			reg = <0x40038810 0x400 0x40038a04 0x3ff 0x400388c0 0x4>;
			regulator-cal-channel = <0x40038888 0x2000 0xd>;
			regulator-default-microvolt = <0xdbba0>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddarm";
			regulator-step-microvolt = <0xc35>;
		};

		vddcama {
			reg = <0x40038814 0x10 0x40038830 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x200 0x16>;
			regulator-default-microvolt = <0x2ab980>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddcama";
			regulator-step-microvolt = <0x2710>;
		};

		vddcamd {
			reg = <0x40038814 0x20 0x4003881c 0x7f 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x2 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x1dc130>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vddcamd";
			regulator-step-microvolt = <0x186a>;
		};

		vddcamio {
			reg = <0x40038814 0x40 0x4003881c 0x7f00 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x3 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x1dc130>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vddcamio";
			regulator-step-microvolt = <0x186a>;
		};

		vddcammot {
			reg = <0x40038814 0x80 0x40038834 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x40 0x17>;
			regulator-default-microvolt = <0x2ab980>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddcammot";
			regulator-step-microvolt = <0x2710>;
		};

		vddcon {
			dcdc;
			reg = <0x40038814 0x2000 0x40038a18 0x3ff 0x0 0x0>;
			regulator-cal-channel = <0x40038888 0xc000 0xd>;
			regulator-default-microvolt = <0x186a00>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddcon";
			regulator-step-microvolt = <0xc35>;
		};

		vddcore {
			dcdc;
			default-on;
			reg = <0x40038810 0x200 0x40038a00 0x3ff 0x400388c0 0x1>;
			regulator-cal-channel = <0x40038888 0x4000 0xd>;
			regulator-default-microvolt = <0xdbba0>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddcore";
			regulator-step-microvolt = <0xc35>;
		};

		vdddcxo {
			default-on;
			reg = <0x40038810 0x20 0x40038838 0xff00 0x400388c0 0x100>;
			regulator-cal-channel = <0x40038844 0x80 0x17>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vdddcxo";
			regulator-step-microvolt = <0x2710>;
		};

		vddemmccore {
			default-on;
			linux,phandle = <0x47>;
			phandle = <0x47>;
			reg = <0x40038810 0x80 0x40038834 0xff00 0x400388c0 0x80>;
			regulator-cal-channel = <0x40038844 0x60 0x17>;
			regulator-default-microvolt = <0x2dc6c0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddemmccore";
			regulator-step-microvolt = <0x2710>;
		};

		vddgen {
			dcdc;
			default-on;
			reg = <0x40038810 0x1000 0x40038a0c 0x3ff 0x400388c0 0x10>;
			regulator-cal-channel = <0x40038888 0x8000 0xd>;
			regulator-default-microvolt = <0x249f00>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddgen";
			regulator-step-microvolt = <0xc35>;
		};

		vddgen0 {
			default-on;
			reg = <0x40038810 0x10 0x40038820 0x7f 0x400388c0 0x2000>;
			regulator-cal-channel = <0x40038844 0x6 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x1dc130>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vddgen0";
			regulator-step-microvolt = <0x186a>;
		};

		vddgen1 {
			default-on;
			reg = <0x40038810 0x40 0x40038824 0x7f00 0x400388c0 0x1000>;
			regulator-cal-channel = <0x40038844 0x5 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x1dc130>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vddgen1";
			regulator-step-microvolt = <0x186a>;
		};

		vddkpled {
			reg = <0x400388f4 0x100 0x400388f4 0xff 0x0 0x0>;
			regulator-cal-channel = <0x400388f8 0x3000 0x18>;
			regulator-default-microvolt = <0x325aa0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddkpled";
			regulator-step-microvolt = <0x2710>;
		};

		vddmem {
			dcdc;
			reg = <0x40038810 0x800 0x40038a08 0x3ff 0x400388c0 0x8>;
			regulator-cal-channel = <0x40038888 0x6000 0xd>;
			regulator-default-microvolt = <0x124f80>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddmem";
			regulator-step-microvolt = <0xc35>;
		};

		vddrf {
			dcdc;
			default-on;
			reg = <0x40038810 0x2000 0x40038a1c 0x3ff 0x400388c0 0x20>;
			regulator-cal-channel = <0x40038888 0xa000 0xd>;
			regulator-default-microvolt = <0x16e360>;
			regulator-max-microvolt = <0x2faf08>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x927c0>;
			regulator-name = "vddrf";
			regulator-step-microvolt = <0xc35>;
		};

		vddrf0 {
			default-on;
			reg = <0x40038810 0x100 0x40038818 0xff00 0x400388c0 0x800>;
			regulator-cal-channel = <0x40038844 0x4 0x15>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x29f630>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x118c30>;
			regulator-name = "vddrf0";
			regulator-step-microvolt = <0x186a>;
		};

		vddsdcore {
			reg = <0x40038814 0x400 0x40038830 0xff00 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0xa0 0x17>;
			regulator-default-microvolt = <0x2dc6c0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddsdcore";
			regulator-step-microvolt = <0x2710>;
		};

		vddsdio {
			linux,phandle = <0x35>;
			phandle = <0x35>;
			reg = <0x40038814 0x1 0x40038828 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x8 0x1d>;
			regulator-default-microvolt = <0x2dc6c0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddsdio";
			regulator-step-microvolt = <0x2710>;
		};

		vddsim0 {
			reg = <0x40038814 0x2 0x40038828 0xff00 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x500 0x16>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddsim0";
			regulator-step-microvolt = <0x2710>;
		};

		vddsim1 {
			reg = <0x40038814 0x4 0x4003882c 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x400 0x16>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddsim1";
			regulator-step-microvolt = <0x2710>;
		};

		vddsim2 {
			reg = <0x40038814 0x8 0x4003882c 0xff00 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x300 0x16>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddsim2";
			regulator-step-microvolt = <0x2710>;
		};

		vddusb {
			linux,phandle = <0x3f>;
			phandle = <0x3f>;
			reg = <0x40038814 0x100 0x4003883c 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x10 0x1d>;
			regulator-default-microvolt = <0x325aa0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddusb";
			regulator-step-microvolt = <0x2710>;
		};

		vddvibr {
			reg = <0x400388f8 0x100 0x400388f8 0xff 0x0 0x0>;
			regulator-cal-channel = <0x400388f8 0x2000 0x18>;
			regulator-default-microvolt = <0x2dc6c0>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddvibr";
			regulator-step-microvolt = <0x2710>;
		};

		vddwifipa {
			linux,phandle = <0x37>;
			phandle = <0x37>;
			reg = <0x40038814 0x800 0x40038818 0xff 0x0 0x0>;
			regulator-cal-channel = <0x40038844 0x20 0x17>;
			regulator-default-microvolt = <0x1b7740>;
			regulator-max-microvolt = <0x395f80>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x124f80>;
			regulator-name = "vddwifipa";
			regulator-step-microvolt = <0x2710>;
		};

		vddwpa {
			dcdc;
			reg = <0x40038814 0x4000 0x40038a10 0x7 0x0 0x0>;
			regulator-cal-channel = <0x40038888 0xe000 0xd>;
			regulator-max-microvolt = <0x33e140>;
			regulator-microvolt-offset = <0x0>;
			regulator-min-microvolt = <0x2faf08>;
			regulator-name = "vddwpa";
			regulator-step-microvolt = <0xc35>;
		};
	};

	saudio_voip {
		compatible = "sprd,saudio";
		sprd,saudio-dst-id = <0x2>;
		sprd,saudio-names = "saudio_voip";
	};

	saudio_w {
		compatible = "sprd,saudio";
		sprd,saudio-dst-id = <0x2>;
		sprd,saudio-names = "saudio_w";
	};

	scproc {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		compatible = "sprd,scproc";
		interrupts = <0x0 0x54 0x0>;
		ranges = <0x300000 0x88300000 0x800000 0x20000 0x88020000 0x220000>;
		reg = <0x88000000 0x1c00000 0xf53d4000 0xc 0xf5230000 0x10000>;
		sprd,ctrl-mask = <0x2000000 0x10000000 0x1 0xf0000>;
		sprd,ctrl-reg = <0x44 0x44 0xb0 0xbc>;
		sprd,iram-data = <0xe59f0000 0xe12fff10 0x88300000>;
		sprd,name = "cpw";

		dsp {
			cproc,name = "dsp";
			reg = <0x20000 0x220000>;
		};

		modem {
			cproc,name = "modem";
			reg = <0x300000 0x800000>;
		};
	};

	sdhci@f5117000 {
		bus-width = <0x4>;
		cd-gpios = <0x47>;
		clock-names = "clk_sdio0";
		clocks = <0x49 0x1c>;
		compatible = "sprd,sdhci-shark";
		d3-gpio = <0x64>;
		d3-index = <0x0>;
		enb-bit = <0x100>;
		gpio-func = <0x3>;
		host-caps-mask = <0x5000000>;
		id = <0x0>;
		interrupts = <0x0 0x39 0x0>;
		keep-power = <0x0>;
		keep-power-in-suspend = <0x1>;
		max-frequency = <0x16e36000>;
		pinmap-offset = <0x184>;
		reg = <0xf5117000 0x1000>;
		rst-bit = <0x800>;
		runtime = <0x1>;
		sd-func = <0x0>;
		sdhci-cap-hw-reset;
		sdhci-cap2-cache-ctrl;
		sdhci-cap2-hc-erase-sz;
		vdd-level = <0x0 0x0 0x1b7740 0x2dc6c0>;
		vdd-vmmc = "vddsdcore";
		vdd-vqmmc = "vddsdcore";
	};

	sdhci@f5118000 {
		bus-width = <0x4>;
		cap-power-off-card = <0x1>;
		clock-names = "clk_sdio1";
		clocks = <0x4a 0xa>;
		compatible = "sprd,sdhci-shark";
		enb-bit = <0x200>;
		id = <0x1>;
		interrupts = <0x0 0x3a 0x0>;
		keep-power = <0x0>;
		keep-power-in-suspend = <0x1>;
		max-frequency = <0x5b8d800>;
		reg = <0xf5118000 0x1000>;
		rst-bit = <0x1000>;
		runtime = <0x1>;
	};

	sdhci@f511c000 {
		bus-width = <0x8>;
		clock-names = "clk_emmc";
		clocks = <0x48 0x1c>;
		compatible = "sprd,sdhci-shark";
		emmc-signal-supply = <0x47>;
		enb-bit = <0x800>;
		host-caps-mask = <0x3000000>;
		id = <0x3>;
		interrupts = <0x0 0x3c 0x0>;
		keep-power = <0x0>;
		keep-power-in-suspend = <0x1>;
		max-frequency = <0x16e36000>;
		non-removable = <0x1>;
		read-neg-delay = <0x4>;
		read-pos-delay = <0x4>;
		reg = <0xf511c000 0x1000>;
		rst-bit = <0x4000>;
		runtime = <0x1>;
		sdhci-cap-1v8-ddr;
		sdhci-cap2-cache-ctrl;
		sdhci-cap2-hc-erase-sz;
		vdd-level = <0x124f80 0x13d620 0x16e360 0x1b7740>;
		write-delay = <0x8>;
	};

	sec-battery {
		battery,adc_check_count = <0x5>;
		battery,battery_check_type = <0x5>;
		battery,cable_check_type = <0x5>;
		battery,cable_source_type = <0x3>;
		battery,charger_name = "sec-charger";
		battery,charging_reset_time = <0x0>;
		battery,charging_total_time = <0x5460>;
		battery,check_adc_max = <0x5a0>;
		battery,check_adc_min = <0x0>;
		battery,check_count = <0x0>;
		battery,chg_gpio_full_check = <0x0>;
		battery,chg_polarity_full_check = <0x1>;
		battery,chip_vendor = "SPRD";
		battery,event_waiting_time = <0x258>;
		battery,fast_charging_current = <0x3cf 0x0 0x3cf 0x3cf 0x3cf 0x3cf 0x3cf 0x3cf 0x0 0x3cf 0x3cf 0x3cf 0x3cf 0xffffffff 0x3cf 0x3cf 0x3cf 0x3cf 0x3cf 0x3cf 0x3cf 0x0 0x0>;
		battery,fuelgauge_name = "sec-fuelgauge";
		battery,full_check_count = <0x1>;
		battery,full_check_current_1st = <0xaf 0x0 0xaf 0xaf 0xaf 0xaf 0xaf 0xaf 0x0 0xaf 0xaf 0xaf 0xaf 0x0 0xaf 0xaf 0xaf 0xaf 0xaf 0xaf 0xaf 0x0 0x0>;
		battery,full_check_current_2nd = <0x708 0x0 0x708 0x708 0x708 0x708 0x708 0x708 0x0 0x708 0x708 0x708 0x708 0x0 0x708 0x708 0x708 0x708 0x708 0x708 0x708 0x0 0x0>;
		battery,full_check_type = <0x7>;
		battery,full_check_type_2nd = <0x3>;
		battery,full_condition_soc = <0x5f>;
		battery,full_condition_type = <0xd>;
		battery,full_condition_vcell = <0x1068>;
		battery,input_current_limit = <0x2bc 0x1cc 0x1cc 0x2bc 0x1cc 0x2bc 0x2bc 0x1cc 0x1cc 0x2bc 0x2bc 0x2bc 0x2bc 0x1cc 0x2bc 0x12c 0x2bc 0x2bc 0x12c 0x2bc 0x2bc 0x1cc 0x1cc>;
		battery,monitor_initial_count = <0x3>;
		battery,ovp_uvlo_check_type = <0x4>;
		battery,polling_time = <0xa 0x1e 0x1e 0x1e 0xe10>;
		battery,polling_type = <0x1>;
		battery,recharge_check_count = <0x1>;
		battery,recharge_condition_soc = <0x5f>;
		battery,recharge_condition_type = <0x4>;
		battery,recharge_condition_vcell = <0x10fe>;
		battery,recharging_total_time = <0x1518>;
		battery,technology = <0x2>;
		battery,temp_adc_type = <0x1>;
		battery,temp_check_count = <0x1>;
		battery,temp_check_type = <0x2>;
		battery,temp_high_recovery_event = <0x1cc>;
		battery,temp_high_recovery_lpm = <0x1cc>;
		battery,temp_high_recovery_normal = <0x1cc>;
		battery,temp_high_threshold_event = <0x258>;
		battery,temp_high_threshold_lpm = <0x258>;
		battery,temp_high_threshold_normal = <0x258>;
		battery,temp_low_recovery_event = <0x0>;
		battery,temp_low_recovery_lpm = <0x0>;
		battery,temp_low_recovery_normal = <0x0>;
		battery,temp_low_threshold_event = <0xffffffce>;
		battery,temp_low_threshold_lpm = <0xffffffce>;
		battery,temp_low_threshold_normal = <0xffffffce>;
		battery,temp_table_adc = <0x1f5 0x267 0x2e2 0x31b 0x34e 0x3bc 0x429 0x440 0x49c 0x51b 0x570 0x5c5 0x65b 0x6f1 0x782 0x832 0x860 0x886 0x8a4 0x8d4 0x8fe 0x994 0x9fb>;
		battery,temp_table_data = <0x2bc 0x28a 0x258 0x244 0x226 0x1f4 0x1cc 0x1c2 0x190 0x15e 0x12c 0xfa 0xc8 0x96 0x64 0x32 0x14 0x0 0xffffffec 0xffffffce 0xffffffba 0xffffff6a 0xffffff38>;
		battery,thermal_source = <0x2>;
		battery,vendor = "SDI SDI";
		charger,vbus_ctrl_gpio = <0x34 0x40 0x0>;
		compatible = "samsung,sec-battery";
	};

	sec-fuelgauge {
		alm_soc = <0x5>;
		alm_vbat = <0xdac>;
		cal_ajust = <0x0>;
		capacity-max = <0x3e8>;
		capacity-max-margin = <0x3e8>;
		capacity-min = <0xa>;
		chg_bat_safety_vol = <0x11f8>;
		cnom = <0x7d0>;
		compatible = "samsung,sec-fuelgauge";
		fg-irq-attr = <0x0>;
		fuel-alert-soc = <0x3e8>;
		gpios = <0x33 0x0 0x0>;
		ocv_table = <0x1112 0x64 0x10ec 0x5f 0x10b5 0x5a 0x107d 0x55 0x1046 0x50 0x1011 0x4b 0xfdf 0x46 0xfb2 0x41 0xf89 0x3c 0xf5d 0x37 0xf29 0x32 0xf0a 0x2d 0xef2 0x28 0xedf 0x23 0xecf 0x1e 0xec2 0x19 0xeb2 0x14 0xe9e 0xf 0xe7f 0xa 0xe63 0x5 0xd48 0x0>;
		relax_current = <0x32>;
		rint = <0xc8>;
		rsense_real = <0xd2>;
		rsense_spec = <0xc8>;
		soft_vbat_uvlo = <0xbea>;
		temp_adc_channel = <0x0>;
		vmode = <0x0>;

		sprd_fgu {
			compatible = "sprd,sprd_fgu";
			interrupt-parent = <0x32>;
			interrupts = <0x4 0x0>;
		};
	};

	sec_thermistor {
		compatible = "sec,thermistor";
	};

	seth0-cpw {
		compatible = "sprd,seth";
		sprd,blknum = <0x80>;
		sprd,channel = <0x7>;
		sprd,dst = <0x2>;
		sprd,name = "rmnet0";
	};

	seth1-cpw {
		compatible = "sprd,seth";
		sprd,blknum = <0x40>;
		sprd,channel = <0x8>;
		sprd,dst = <0x2>;
		sprd,name = "rmnet1";
	};

	seth2-cpw {
		compatible = "sprd,seth";
		sprd,blknum = <0x40>;
		sprd,channel = <0x9>;
		sprd,dst = <0x2>;
		sprd,name = "rmnet2";
	};

	sipc-common {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		compatible = "sprd,sipc";
		ranges = <0x8000000 0x88000000 0x1c00000 0x7800000 0x87800000 0x180000 0x9bff000 0x89bff000 0x1000>;
		reg = <0x87800000 0x240000>;

		sipc_cpw {
			interrupts = <0x0 0x44 0x0>;
			reg = <0x8000000 0x1c00000 0x7800000 0x180000 0x9bff000 0x1000>;
			sprd,ap2cp = <0xf5240000>;
			sprd,clr = <0x1>;
			sprd,cp2ap = <0xf5240004>;
			sprd,dst = <0x2>;
			sprd,name = "sipc-w";
			sprd,trig = <0x1>;
		};
	};

	slog-cpw {
		compatible = "sprd,spipe";
		sprd,channel = <0x5>;
		sprd,dst = <0x2>;
		sprd,name = "slog_w";
		sprd,ringnr = <0x1>;
		sprd,size-rxbuf = <0x40000>;
		sprd,size-txbuf = <0x8000>;
	};

	spi@70a00000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		clock-names = "clk_spi0";
		compatible = "sprd,sprd-spi";
		interrupts = <0x0 0x7 0x0>;
		reg = <0xf5376000 0x1000>;
	};

	spi@70b00000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		clock-names = "clk_spi1";
		compatible = "sprd,sprd-spi";
		interrupts = <0x0 0x8 0x0>;
		reg = <0xf5378000 0x1000>;
	};

	spi@70c00000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		clock-names = "clk_spi2";
		compatible = "sprd,sprd-spi";
		interrupts = <0x0 0x9 0x0>;
		reg = <0xf537a000 0x1000>;
	};

	spipe-cpw {
		compatible = "sprd,spipe";
		sprd,channel = <0x4>;
		sprd,dst = <0x2>;
		sprd,name = "spipe_w";
		sprd,ringnr = <0x9>;
		sprd,size-rxbuf = <0x1000>;
		sprd,size-txbuf = <0x1000>;
	};

	sprd-audio-devices {
		#address-cells = <0x1>;
		#size-cells = <0x1>;
		compatible = "sprd,sound";

		bt-i2s-config {
			sprd,def_pcm_config;
		};

		fm-i2s-config {
		};

		i2s@0 {
			compatible = "sprd,i2s";
			linux,phandle = <0x2c>;
			phandle = <0x2c>;
			sprd,base = <0x70d00000 0xf537c000>;
			sprd,dai_name = "i2s_bt_sco0";
			sprd,dma_rx_no = <0x3>;
			sprd,dma_tx_no = <0x4>;
			sprd,hw_port = <0x0>;
			sprd,id = <0x0>;
			status = "okay";
		};

		i2s@1 {
			compatible = "sprd,i2s";
			linux,phandle = <0x2d>;
			phandle = <0x2d>;
			sprd,base = <0x70e00000 0xf5380000>;
			sprd,dai_name = "i2s_bt_sco1";
			sprd,dma_rx_no = <0x5>;
			sprd,dma_tx_no = <0x6>;
			sprd,hw_port = <0x1>;
			sprd,id = <0x1>;
			status = "okay";
		};

		i2s@2 {
			compatible = "sprd,i2s";
			linux,phandle = <0x2e>;
			phandle = <0x2e>;
			sprd,base = <0x70f00000 0xf5382000>;
			sprd,dai_name = "i2s_bt_sco2";
			sprd,dma_rx_no = <0x7>;
			sprd,dma_tx_no = <0x8>;
			sprd,hw_port = <0x2>;
			sprd,id = <0x2>;
			status = "okay";
		};

		i2s@3 {
			compatible = "sprd,i2s";
			linux,phandle = <0x2f>;
			phandle = <0x2f>;
			sprd,base = <0x71000000 0xf5384000>;
			sprd,dai_name = "i2s_bt_sco3";
			sprd,dma_rx_no = <0x9>;
			sprd,dma_tx_no = <0xa>;
			sprd,hw_port = <0x3>;
			sprd,id = <0x3>;
			status = "okay";
		};

		null-codec {
			compatible = "sprd,null-codec";
			linux,phandle = <0x30>;
			phandle = <0x30>;
		};

		sound@0 {
			compatible = "sprd,vbc-r2p0-sprd-codec";
			sprd,codec = <0x29>;
			sprd,model = "sprdphone";
			sprd,pcm = <0x2a>;
			sprd,vaudio = <0x27>;
			sprd,vbc = <0x28>;
		};

		sound@1 {
			compatible = "sprd,vbc-r2p0-sprd-codec-v3";
			sprd,codec = <0x2b>;
			sprd,model = "sprdphone";
			sprd,pcm = <0x2a>;
			sprd,vaudio = <0x27>;
			sprd,vbc = <0x28>;
		};

		sound@2 {
			compatible = "sprd,i2s-null-codec";
			sprd,codec = <0x30>;
			sprd,i2s = <0x2c 0x2d 0x2e 0x2f>;
			sprd,model = "all-i2s";
			sprd,pcm = <0x2a>;
		};

		sprd-codec {
			compatible = "sprd,sprd-codec";
			linux,phandle = <0x29>;
			phandle = <0x29>;
			sprd,ap_irq = <0xa4>;
			sprd,audio_power_ver = <0x4>;
			sprd,def_da_fs = <0xac44>;
			sprd,dp_irq = <0x34>;
			status = "okay";
		};

		sprd-codec-v1 {
			compatible = "sprd,sprd-codec-v1";
			sprd,ap_irq = <0x67>;
			sprd,def_da_fs = <0xac44>;
			sprd,dp_irq = <0x3f>;
			status = "disable";
		};

		sprd-codec-v3 {
			compatible = "sprd,sprd-codec-v3";
			linux,phandle = <0x2b>;
			phandle = <0x2b>;
			sprd,ap_irq = <0xa4>;
			sprd,def_da_fs = <0xac44>;
			sprd,dp_irq = <0x34>;
			status = "disable";
		};

		sprd-pcm-audio {
			compatible = "sprd,sprd-pcm";
			linux,phandle = <0x2a>;
			phandle = <0x2a>;
		};

		vaudio {
			compatible = "sprd,vaudio";
			linux,phandle = <0x27>;
			phandle = <0x27>;
		};

		vbc-r1p0 {
			compatible = "sprd,vbc-r1p0";
			status = "disable";
		};

		vbc-r2p0 {
			compatible = "sprd,vbc-r2p0";
			linux,phandle = <0x28>;
			phandle = <0x28>;
			status = "okay";
		};
	};

	sprd_dcam {
		clock-names = "clk_mm_i", "clk_dcam";
		clocks = <0x22 0x42>;
		compatible = "sprd,sprd_dcam";
		interrupts = <0x0 0x2d 0x0>;
		reg = <0xf52f0000 0x100000>;
	};

	sprd_dma_copy {
		compatible = "sprd,sprd_dma_copy";
	};

	sprd_iommu@F5410000 {
		clock-names = "clk_gsp_emc", "clk_153m6", "clk_gsp";
		clocks = <0x3e 0xc 0x3d>;
		compatible = "sprd,sprd_iommu";
		func-name = "sprd_iommu_gsp";
		reg = <0x10000000 0x2000000 0xf5410000 0x8000 0xf5418000 0x8000>;
		reg_name = "iova", "pgt", "ctrl_reg";
		status = "ok";
	};

	sprd_iommu@F5430000 {
		clock-names = "clk_mmu", "clk_mm_i";
		clocks = <0x4b 0x22>;
		compatible = "sprd,sprd_iommu";
		func-name = "sprd_iommu_mm";
		reg = <0x20000000 0x8000000 0xf5430000 0x20000 0xf5450000 0x2000>;
		reg_name = "iova", "pgt", "ctrl_reg";
		status = "ok";
	};

	sprd_isp {
		clock-names = "clk_mm_i", "clk_isp";
		clocks = <0x22 0x46>;
		compatible = "sprd,sprd_isp";
	};

	sprd_jpg {
		clock-names = "clk_mm_i", "clk_jpg";
		clocks = <0x22 0x41>;
		compatible = "sprd,sprd_jpg";
		interrupts = <0x0 0x2a 0x0>;
		reg = <0xf5320000 0x8000>;
	};

	sprd_rotation {
		compatible = "sprd,sprd_rotation";
	};

	sprd_scale {
		compatible = "sprd,sprd_scale";
	};

	sprd_sensor {
		clock-names = "clk_mm_i", "clk_sensor", "clk_ccir", "clk_dcam", "clk_dcam_mipi";
		clocks = <0x22 0x43 0x44 0x42 0x45>;
		compatible = "sprd,sprd_sensor";
		gpios = <0x34 0xba 0x0 0x34 0xbc 0x0 0x34 0xee 0x0 0x34 0xbb 0x0 0x34 0xa5 0x0>;
	};

	sprd_thermal {
		compatible = "sprd,sprd-thermal";
		id = <0x0>;
		interrupts = <0x0 0x1a 0x0>;
		reg = <0xf5260000 0x1000>;
		trip_num = <0x4>;
		trip_points_active = <0x50 0x58 0x64>;
		trip_points_critical = <0x6e>;
		trip_points_lowoff = <0x48 0x48 0x51>;
	};

	sprd_thermal1 {
		compatiable = "sprd,sprd-thermal";
		id = <0x1>;
		interrupt-parent = <0x32>;
		interrupts = <0x9 0x0>;
		reg = <0xf53f8280 0x1000>;
		trip_num = <0x2>;
		trip_points_active = <0x5a>;
		trip_points_critical = <0x72>;
		trip_points_lowoff = <0x51>;
	};

	sprd_vsp@f5300000 {
		clock-names = "clk_mm_i", "clk_vsp";
		clocks = <0x22 0x40>;
		compatible = "sprd,sprd_vsp";
		interrupts = <0x0 0x2b 0x0>;
		reg = <0xf5300000 0xc000>;
	};

	stty-cpw {
		compatible = "sprd,spipe";
		sprd,channel = <0x6>;
		sprd,dst = <0x2>;
		sprd,name = "stty_w";
		sprd,ringnr = <0x20>;
		sprd,size-rxbuf = <0x800>;
		sprd,size-txbuf = <0x800>;
	};

	timer {
		compatible = "sprd,scx35-timer";
		interrupts = <0x0 0x76 0x0 0x0 0x1c 0x0 0x0 0x1d 0x0 0x0 0x77 0x0 0x0 0x79 0x0>;
		reg = <0xf5204000 0x1000 0xf51f4000 0x1000 0xf5202000 0x1000 0xf5292000 0x1000 0xf5294000 0x1000>;
	};

	uart@f5360000 {
		clock-names = "clk_uart0";
		clocks = <0x31 0x3c>;
		compatible = "sprd,serial";
		interrupts = <0x0 0x2 0x0>;
		reg = <0xf5360000 0x1000>;
		sprdclk = <0x2dc6c00>;
		sprdwaketype = "BT_RTS_HIGH_WHEN_SLEEP";
	};

	uart@f5362000 {
		clock-names = "clk_uart1";
		clocks = <0x31 0x3d>;
		compatible = "sprd,serial";
		interrupts = <0x0 0x3 0x0>;
		reg = <0xf5362000 0x1000>;
		sprdclk = <0x18cba80>;
		sprdwaketype = "BT_RTS_HIGH_WHEN_SLEEP";
	};

	uart@f5364000 {
		clock-names = "clk_uart2";
		clocks = <0x31 0x3e>;
		compatible = "sprd,serial";
		interrupts = <0x0 0x4 0x0>;
		reg = <0xf5364000 0x1000>;
		sprdclk = <0x18cba80>;
		sprdwaketype = "BT_RTS_HIGH_WHEN_SLEEP";
	};

	uart@f5366000 {
		clock-names = "clk_uart3";
		clocks = <0x31 0x3f>;
		compatible = "sprd,serial";
		interrupts = <0x0 0x5 0x0>;
		reg = <0xf5366000 0x1000>;
		sprdclk = <0x18cba80>;
		sprdwaketype = "BT_RTS_HIGH_WHEN_SLEEP";
	};

	usb@f5116000 {
		#address-cells = <0x1>;
		#size-cells = <0x0>;
		compatible = "sprd,usb";
		gpios = <0x33 0x0 0x0 0x34 0x48 0x0>;
		interrupts = <0x0 0x37 0x0>;
		ngpios = <0x2>;
		reg = <0xf5116000 0x1000>;
		usb-supply = <0x3f>;
	};
};
